<?php 
  /* ***** BEGIN LICENSE BLOCK *****
  * This is a plugin for DotClear.
  *
  * DotClear is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  * 
  * DotClear is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  * 
  * You should have received a copy of the GNU General Public License
  * along with DotClear; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * ***** END LICENSE BLOCK *****
  */
/*******************************************************************************
* Les fonctions de compatibilit, utilitaires - hors classe
*******************************************************************************/

	if(!function_exists('stripos'))
  {
    function stripos($haystack,$needle,$offset = 0) {
     return(strpos(strtolower($haystack),strtolower($needle),$offset));
    }
  }
  function strip_multiple_blanks($str)
  {
    return preg_replace('/\s+/', ' ', trim($str));
  }
  
class podcast
{
/*******************************************************************************
* Les fonctions utilitaires
*******************************************************************************/

  /*
  function html_wiki($str)
  {
  	return str_replace(array('</p>', '<br>', '<br/>', '<br />'),
                       array('</p>%%%', '<br>%%%', '<br/>%%%', '<br />%%%'), $str);
  }
  # */
  function take($str, $length, $suffix = '...')
  {
  	# La fonction take coupe la chaine  n octets, au dernier blanc (s'il existe)
    # MBstring n'est pas utilis (pas disponible sur tous les serveurs)
    # les chaines des blogs en UTF-8 seront coupes en octets avant la limite de 255 ou 4000 caractres
    # les blancs au dbut et  la fin sont ne sont pas supprims par iTunes
    $str = trim($str); 
  	if ( strlen($str) <= $length ) return $str;
    $str = substr($str, 0, $length - strlen($suffix));
    if ( ($blk = strrpos($str, ' ') ) !== false ) $str = substr($str, 0, $blk);
  	return $str.$suffix;
  }
  function encode_str($str)
  {
    # le but est de valider strictement dans Feed validator
    $str = trim($str); # enlve blancs dbut fin
    # on traite & (marqueur XML) ; < > (marqueur HTML) ; " (protection MySQL)
    return str_replace(array('&', '<', '>', '"'), array('&amp;', '&lt;', '&gt;', '&quot;'), $str);
    # on traite & (marqueur XML) ; " (protection MySQL)
    #return str_replace(array('&', '"'), array('&amp;', '&quot;'), $str);
  }
  function decode_str($str)
  {
    # on garde &amp;xxx &lt; &gt; (marqueurs XML HTML) et on rtablit " ' & &#
    # pour raffichage dans la partie admin du plugin, pas dans gen fils RSS
    return str_replace(array('&quot;', ' &amp; ', '&amp;#', '&amp;apos'),
                       array('"', ' & ', '&#', "'"), $str);
  }
  function str_url($str, $ucfirst=0)
  { # doit se conformer  str2url PHP JS de DotClear
    $str = strtr($str,
    "",
    "AAAAAAaaaaaaCcOOOOOOooooooEEEEeeeeIIIIiiiiUUUUuuuuYYyyNn");
    $str = str_replace('','AE',$str);
    $str = str_replace('','ae',$str);
    $str = str_replace('','OE',$str);
    $str = str_replace('','oe',$str);
    $str = preg_replace('/[^a-z0-9_\s\'\:\/\[\]-]/','',strtolower($str));
    $str = preg_replace('/[\s\'\:\/\[\]-]+/',' ',trim($str));
    $res = str_replace(' ','-',$str);
    if ($ucfirst) $res = ucfirst($res);
    return $res;
  }
  # pour les spcification de chemin dans les spcifications
  function file_of($str)
  {
  	if (substr($str, 0, 1) == '/') { # chemin absolu : racine du site
    	return $_SERVER['DOCUMENT_ROOT'] . $str;
    } else { # chemin relatif depuis le blog
    	return $_SERVER['DOCUMENT_ROOT'] . dc_app_url . '/' . $str;
    }
  }
  # pour les spcification de chemin dans les spcifications
  function url_of($str)
  {
  	if (substr($str, 0, 1) == '/') { # chemin absolu : racine du site
      return util::getHost() . $str;
    } else { # chemin relatif depuis le blog
    	return util::getHost() . dc_app_url . '/' . $str;
    }
  }
  # prfixer un URL pour des besoins de statistiques
  function url_prefix($url)
  {
  	if (dc_podcast_prefix == 'no') return '';
		ereg("\.([^\.]*$)", $url, $elts);
		$extm = strtolower(trim($elts[1]));
    if (dc_podcast_prefix == 'tharos') {
      # prfixe compteur tlchargement
      return util::getHost().dc_app_url.'/index.'.$extm.'?download=';
    } elseif (dc_podcast_prefix == 'podtrac') { 	
      # prfixe Podtrac
      return 'http://get.podemus.com/fredooo13/'.$extm.'?';
    }
  }
  # mots-cls : limitation  12, sparateur virgule
  function take_keywords($keywords, $limit=12) {
    $keywords = strip_multiple_blanks($keywords);
    if (strpos($keywords, ',') === false) {
    	$key_array = explode(' ', $keywords);
    } else {
    	$key_array = explode(',', $keywords);
    }
    $key_array = array_map("strip_multiple_blanks", $key_array);
    if (count($key_array) > 12) $key_array = array_slice($key_array, 0, 12);
    return implode(',', $key_array);
  }
  # mise en forme standard 'nospam@nospam.com'.'('.dc_blog_name.')'
  # format_editor($editor, '') -> nospam@nospam.com(name)
  # format_editor($editor, 'email') -> nospam@nospam.com
  # format_editor($editor, 'name') -> name
  function format_editor($editor, $result='', $email='nospam@nospam.com') {
  	$editor = strip_multiple_blanks($editor);
    if ($editor == '') {
	    $editor = $email.'('.dc_blog_name.')';
    } else {
      if ( (strpos($editor, '@') === false) AND (strpos($editor, '(') === false) ) {
  	    $editor = $email.'('.$editor.')';
      } elseif ( (strpos($editor, '@') !== false) AND (strpos($editor, '(') === false) ) {
  	    $editor = $editor.'('.dc_blog_name.')';
      }
    }
    if ($result == 'name') {
	    return trim(eregi_replace( '(^.*\()|(\).*)' , '', $editor));
    } elseif ($result == 'email') {
	    return trim(eregi_replace( '(\(.*)' , '', $editor));
    } else {
    return $editor;
    }
  }
	# copie de fichier dans /share/podcast s'il n'y est pas
  function copyShare($fn, $replace='no') {
  	global $dc_podcast_plugin_name;
    if ( (@file_exists(DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$fn)) AND ($replace == 'no') ) return true;
    if ( @copy(DC_PODCAST_ROOT.$fn, DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$fn) ) {
     buffer::str('<p><strong>'.$fn . '</strong> '.__('copied to').' share/podcast</p>');
     return true;
    } else {
      buffer::str('<div class="erreur"><p><strong>'.$fn . '</strong> '.__('not').' '.__('copied to').' share/podcast</p></div>');
      return false;
    }
  }
  # pour affichage
  function DisplayYesNo($V)
  {
    if ($V === 'true' || $V === '1' || $V === 1) {
      return __('Yes');
    } elseif (strtolower($V) == 'yes' || strtolower($V) == 'oui') {
      return __('Yes');
    } elseif ($V === 'false' || $V === '0' || $V === 0) {
      return __('No');
    } elseif ($V == '' || strtolower($V) == 'no' || strtolower($V) == 'non') {
      return __('No');
    } else {
    	return ucfirst($V);
    }
  }
  
  function DisplayErrors($errors)
  {
    if (count($errors) > 0) {
    $list = '<ul>';
    foreach ($errors as $errors_value) $list .= '<li>' . $errors_value . '</li>';
    $list .= '</ul>';
    buffer::str('<div class="erreur"><p><strong>' . __('Error(s)') .
    ' :</strong></p>' . $list . '</div>');
    }
  }
  
  function DisplayResults($results, $msg = 'gen')
  {
  	# results : key / nbr items
    # podcast::file_of(constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1)).'.'.dc_podcast_feed_ext
    # podcast::url_of(constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1).'.'.dc_podcast_feed_ext
    # http://www.feedvalidator.org/check.cgi?url=http://cvie.free.fr/blog/share/feeds/podcast.xml
    # '<img alt="valid-rss (1K)" src="valid-rss.png" height="31" width="88" />'

    global $feed_names;
    if (count($results) > 0) {
  		$dc_podcast_feeds = 'yes';
  	} else {
  		$dc_podcast_feeds = 'no';
  	}
  	if ($dc_podcast_feeds != dc_podcast_feeds)
  		podcast::updConf('dc_podcast_feeds', $dc_podcast_feeds, '', '', 0);
    if ( count($results) == 0 ) return;
  	if ( $msg == 'gen' ) { # dition pour Gen RSS
    	$tag_msg_beg = '<p class="message">'; $tag_msg_end = '</p>';
      $tag_rss_beg = '<p>'; $tag_rss_end = '</p>'; 
    } else { # dition compacte pour edit
    	$tag_msg_beg = '<br /><em>'; $tag_msg_end = '</em>';
      $tag_rss_beg = '<br />'; $tag_rss_end = '';
    }
    buffer::str($tag_msg_beg. __('RSS feed(s) updated') . $tag_msg_end);
    foreach ($results as $value) {
	    $item = '';
  		$res_array = explode('/', $value);
      $ext = dc_podcast_feed_ext;
      if ( count($res_array) == 1 ) $ext ='php';
      $url = podcast::url_of( constant('dc_podcast_rss_2_0_feed_path'.$res_array[0]).
      	substr($res_array[0], 1).'.'.$ext);
      $url_dsp = '<a href="'.$url.'">'.substr($res_array[0], 1).'.'.$ext.'</a>';
      if ( count($res_array) > 1 ) $item = ' - item(s): '.$res_array[1];
      $valid_rss = '<a href="http://www.feedvalidator.org/check.cgi?url='.$url.'"> validation </a>';
     	buffer::str($tag_rss_beg.'<strong>'.$feed_names[$res_array[0]].' :</strong> '.
      	$url_dsp.''.$item.' - '.$valid_rss.$tag_rss_end);
    }
  }
  
  function DisplayFeeds()
  {
    global $feed_names, $dc_podcast_plugin_name;
    $str = '<p>';
    foreach ($feed_names as $key => $value) {
      $ext_array = array(dc_podcast_feed_ext, 'php');
      foreach ($ext_array as $ext) {
      	if ( defined('dc_podcast_rss_2_0_feed_path'.$key) ) {
      	$ad = constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1).'.'.$ext;
          if ( @file_exists(podcast::file_of($ad)) ) {
          	$str.= '<strong>'.$value.' :</strong> '.'<a href="'.podcast::url_of($ad).'">'.substr($key, 1).'.'.$ext.'</a>'.
            ' - '.'<a href="http://www.feedvalidator.org/check.cgi?url='.
            podcast::url_of($ad).'"> validation</a>'.
            ' <br /><small>&lt;a href="'.podcast::url_of($ad).'"&gt;&lt;img src="share/'.
            $dc_podcast_plugin_name.'/grey-podcast-2.png" height="22" width="70" alt="'.$value.'" /&gt;&lt;/a&gt;</small><br />';
  				} else {
          	$str.= 'Le fil de syndication RSS2 <strong>'.$value.' en '.$ext.
          	' :</strong> n\'existe pas. Cliquer sur <strong>GenRSS</strong> dans la page de liste des pisodes.<br />';
          }
        }	else {
        	$str.= 'Les spcifications de <strong>'.$value.
          	' :</strong> n\'existent pas. <strong>Enregistrer</strong> ces spcifications.<br />';
        }      
      }
    }
    $str.= '<small>Note : le code HTML du ou des fils  afficher est  mettre dans le template.php,' .
    ' dans la liste des fils de syndication. Rajouter les balises adquates (&lt;li&gt;&lt;/li&gt; &hellip;).</small>';
    return $str.'</p>';
  }
/*******************************************************************************
* Les fonctions de traitement pour le podcast
*******************************************************************************/
	# nom complet fichier, url complte, nom du fil RSS
  function generate_php_feed($fn, $url, $name)
  {
  	global $con, $blog, $errors;
    $rc = true;
    $feed = '<?php '."\n";
    $feed.= 'header(\'Content-Type: text/xml; charset=UTF-8\');'."\n";
    $feed.= '$handle = fopen(\''.$url.'\', "r");'."\n";
    $feed.= 'while ($buffer = fgets($handle,4096)) echo $buffer;'."\n";
    $feed.= 'fclose($handle);'."\n";
    $feed.= 'if (file_exists(\'../../'.DC_ECRIRE.'/tools/bbclonerss/functions.php\')) {'."\n";
    $feed.= ' include \'../../'.DC_ECRIRE.'/tools/bbclonerss/functions.php\';'."\n";
    $feed.= ' require( bbclonerss::counter( "'.$name.'" ) );'."\n";
    $feed.= '}'."\n";
    $feed.= ' ?>'."\n";
  	# save the RSS file
    $feedFile = fopen($fn, "w+");
    if ($feedFile) {
      fputs($feedFile,$feed);
      fclose($feedFile);
    } else {
      $errors[] = __('Error creating podcast, please check write permissions.');
      $rc = false;
    }
  } # fin de generate_php_feed
  
  # cration du fil de syndication RSS 2.0
  # les items, le suffixe du fichier, les noms de fil pour slection
  # return nbr items or false
  # $select = vide pour le fil gnral ; sinon le nom du fil RSS spcifique
  function generate_feed($data, $key, $select='')
  {
    global $con, $blog, $plugin_gen, $errors;
    $rc = true; $check_guid = array(); $nbr_items = 0;
    # on gnre le fil de syndication pour chaque format
    $feed = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    $feed.= "<rss version=\"2.0\" xml:lang=\"en\"\n";    $feed.= "xmlns:itunes=\"http://www.itunes.com/dtds/podcast-1.0.dtd\"\n";
    $feed.= "xmlns:creativeCommons=\"http://backend.userland.com/creativeCommonsRssModule\"\n";
    $feed.= "xmlns:dc=\"http://purl.org/dc/elements/1.1/\"\n";
    $feed.= "xmlns:content=\"http://purl.org/rss/1.0/modules/content/\"\n";
    $feed.= "xmlns:sy=\"http://purl.org/rss/1.0/modules/syndication/\">\n";
    
    # 1.3.7 : les valeurs des champs texte de conf.ini ne sont plus protgs par CDATA   
    # Specs 2005-12-07 CDATA sections are strongly discouraged.
    $feed.= "  <channel>\n";
    if (constant('dc_podcast_itunes_new_feed'.$key) != '')
    	$feed.= "    <itunes:new-feed-url>".constant('dc_podcast_itunes_new_feed'.$key)."</itunes:new-feed-url>\n";
    $feed.= "    <ttl>".constant('dc_podcast_feed_ttl'.$key)."</ttl>\n";
    $dc_podcast_feed_title = (constant('dc_podcast_feed_title'.$key) == '') ? dc_blog_name :
    	constant('dc_podcast_feed_title'.$key);
    $feed.= "    <title>".$dc_podcast_feed_title."</title>\n";
    if (dc_podcast_feed_post == '') {
    	$link_value = "    <link>".util::getHost().dc_blog_url."</link>\n";
    } elseif (substr(constant('dc_podcast_feed_post'.$key), 0, 7) == 'http://') {
    	$link_value = "    <link>".constant('dc_podcast_feed_post'.$key)."</link>\n";
    } else {
    	$link_value = "    <link>http://".constant('dc_podcast_feed_post'.$key)."</link>\n";
    }
    $feed.= $link_value;
    $dc_podcast_itunes_subtitle = (constant('dc_podcast_itunes_subtitle'.$key) == '') ? dc_blog_name :
    	constant('dc_podcast_itunes_subtitle'.$key);
    $dc_podcast_itunes_subtitle = podcast::take(strip_tags(str_replace(DC_PODCAST_CR,"\r",$dc_podcast_itunes_subtitle)), 255);
    $feed.= "    <description>".$dc_podcast_itunes_subtitle."</description>\n";
    $feed.= "    <itunes:subtitle>".$dc_podcast_itunes_subtitle."</itunes:subtitle>\n";
    if (constant('dc_podcast_itunes_summary'.$key) != '')
	    $feed.= "    <itunes:summary>".podcast::take(strip_tags(str_replace(DC_PODCAST_CR,"\r",constant('dc_podcast_itunes_summary'.$key))), 4000)."</itunes:summary>\n";
    if (constant('dc_podcast_itunes_explicit'.$key) != '')
    	$feed.= "      <itunes:explicit>".constant('dc_podcast_itunes_explicit'.$key)."</itunes:explicit>\n";
    $feed.= "    <language>".constant('dc_podcast_feed_lang'.$key)."</language>\n";
    $feed.= "    <copyright>".constant('dc_podcast_feed_copyr'.$key)."</copyright>\n";
    if ( (constant('dc_podcast_feed_license'.$key) != '') AND (substr(constant('dc_podcast_feed_license'.$key), 0 ,strlen(DC_PODCAST_CCL)) == DC_PODCAST_CCL) ) {
      $feed.= "    <creativeCommons:license>".constant('dc_podcast_feed_license'.$key)."</creativeCommons:license>\n";
    }
    if (constant('dc_podcast_feed_editor'.$key) != '') {
      $feed.= "    <managingEditor>".podcast::format_editor(constant('dc_podcast_feed_editor'.$key))."</managingEditor>\n";
      $feed.= "    <webMaster>".podcast::format_editor(constant('dc_podcast_feed_editor'.$key))."</webMaster>\n";
      $feed.= "    <itunes:author>".podcast::format_editor(constant('dc_podcast_feed_editor'.$key), 'name')."</itunes:author>\n";
      $feed.= "    <itunes:owner>\n";
      $feed.= "      <itunes:name>".podcast::format_editor(constant('dc_podcast_feed_editor'.$key), 'name')."</itunes:name>\n";
      $feed.= "      <itunes:email>".podcast::format_editor(constant('dc_podcast_feed_editor'.$key), 'email')."</itunes:email>\n";
      $feed.= "    </itunes:owner>\n";
    }
    if (constant('dc_podcast_channel_pubdate'.$key) == '') {
      $feed.= "    <pubDate>".htmlspecialchars(date('D, j M Y H:i:s O'))."</pubDate>\n";
    } else {
      $feed.= "    <pubDate>".constant('dc_podcast_channel_pubdate'.$key)."</pubDate>\n";
    }
    $feed.= "    <lastBuildDate>".htmlspecialchars(date('D, j M Y H:i:s O'))."</lastBuildDate>\n";
    $cats = explode(',', constant('dc_podcast_feed_category'.$key));
    if (count($cats) > 0) {
      foreach($cats as $cats_key => $cats_value) {
  			$feed.= "    <category>".trim($cats_value)."</category>\n";
  		}
    }
    if ( trim(constant('dc_podcast_feed_cat_itun'.$key)) != '' ) {
    	$cats = explode(',', constant('dc_podcast_feed_cat_itun'.$key));
      if (count($cats) > 0) {
        $feed.= "    <itunes:category text=\"".trim($cats[0])."\">\n";
        if (count($cats) > 1)
        	$feed.= "      <itunes:category text=\"".trim($cats[1])."\">\n";
        $feed.= "    </itunes:category>\n";
      }
    }
    $feed.= "    <generator>".$plugin_gen."</generator>\n";
    
    if (dc_podcast_feed_image != '') {
      $url = podcast::url_of(constant('dc_podcast_feed_image'.$key));
      $filename = podcast::file_of(constant('dc_podcast_feed_image'.$key));
      if (file_exists($filename)) {
        if (getimagesize($filename) !== false) {
          $size = getimagesize($filename);
          $feed.= "    <image>\n";
          $feed.= "      <url>".$url."</url>\n";
          $feed.= "      <title>".constant('dc_podcast_feed_title'.$key)."</title>\n";
          $feed.= "      <width>".$size[0]."</width>\n";
          $feed.= "      <height>".$size[1]."</height>\n";
          $feed.= $link_value;
          $feed.= "    </image>\n";
        } else {
          $errors[] = 'filesize for ' . $filename . ' ' . __('not found');
          $rc = false;
        }
      } else {
        $errors[] = $filename . ' ' . __('not found');
        $rc = false;
      }
    }
    if ( constant('dc_podcast_itunes_image'.$key) != '' ) {
     $url = podcast::url_of(constant('dc_podcast_itunes_image'.$key));
     $filename = podcast::file_of(constant('dc_podcast_itunes_image'.$key));
      if (file_exists($filename)) {
          $feed.= "    <itunes:image href=\"".$url."\" />\n";
      } else {
        $errors[] = $filename . ' ' . __('not found');
        $rc = false;
      }
    }
    if ( ($keywords = constant('dc_podcast_itunes_keywords'.$key)) != '') {
			$feed.= "      <itunes:keywords>".podcast::take_keywords($keywords)."</itunes:keywords>\n";
    }
    # traitement de chaque entre
    foreach($data as $data_key => $data_value)
    {
    	if ($data_value['status'] == '0') continue;
      $ignore_item = ( ( $select == '' ) ? false : true );
      if ($select != '') { # slection par noms de fils RSS de l'item pour le fil RSS spcifique $select
        if ($data_value['marks'] != '') {
        	$item_marks = explode(',', $data_value['marks']); # tableau des marqueurs de l'item
          $item_marks = array_map("strip_multiple_blanks", $item_marks);
          $item_marks = array_map("strtolower", $item_marks);
          if ( array_search(strtolower($select), $item_marks) !== false ) $ignore_item = false;
        }
      }
      if ( $ignore_item ) continue;
      ++$nbr_items;
      # pour valider les noms de fichier avec lettres accentues
      $url_split = strrpos($data_value['url'], '/') + 1;
      $urlp = substr($data_value['url'], 0, $url_split) .
              rawurlencode(substr($data_value['url'], $url_split));
      $feed.= "    <item>\n";
      $dc_podcast_item_title = ($data_value['title'] == '') ?
      	(__('Item') . ' - ' . date('D, j M Y H:i:s O')) : $data_value['title'];
      $feed.= "      <title>".$dc_podcast_item_title."</title>\n";
      if ($data_value['post'] == '') {
        $feed.= "      <link>".util::getHost().dc_blog_url."</link>\n";
      } else {
        $feed.= "      <link>".htmlspecialchars($data_value['post'])."</link>\n";
      }
      if ($data_value['comments'] == '') {
        $feed.= "      <comments>".util::getHost().dc_blog_url."</comments>\n";
      } else {
        $feed.= "      <comments>".$data_value['comments']."</comments>\n";
      }
      $dc_podcast_item_descf = ($data_value['descf'] == '') ? dc_blog_name : ($data_value['descf']);
      $dc_podcast_item_descf = podcast::take(strip_tags($dc_podcast_item_descf), 255);
      $feed.= "      <description>".$dc_podcast_item_descf."</description>\n";
      if (($data_value['author'] != '') AND strpos($data_value['author'], '@')) 
        $feed.= "      <author>".$data_value['author']."</author>\n"; # si email pas nom
			$cats = explode(',', $data_value['category']);
	    foreach($cats as $cats_value) {        
	      $feed.= "      <category>".trim($cats_value)."</category>\n";
      }
      if ( ($data_value['license'] != '')  AND (substr($data_value['license'], 0 ,strlen(DC_PODCAST_CCL)) == DC_PODCAST_CCL) ) {
      $feed.= "      <creativeCommons:license>".$data_value['license']."</creativeCommons:license>\n";
    	}
      if ($data_value['author'] != '')
        $feed.= "      <itunes:author>".$data_value['author']."</itunes:author>\n";
      $feed.= "      <itunes:subtitle>".$dc_podcast_item_descf."</itunes:subtitle>\n";
      if ($data_value['summary'] != '')
        $feed.= "      <itunes:summary>".podcast::take(strip_tags($data_value['summary']), 4000)."</itunes:summary>\n";
      if ($data_value['duration'] != '')
        $feed.= "      <itunes:duration>".$data_value['duration']."</itunes:duration>\n";
      if ($data_value['explicit'] != '')
      	# pour champ MySQL cr en 1.3.x
      	if ($data_value['explicit'] == '0') {
        	$item_explicit = 'no';
        } elseif ($data_value['explicit'] == '1') {
        	$item_explicit = 'yes';
        } else {
        	$item_explicit = $data_value['explicit'];
        }
      	$feed.= "      <itunes:explicit>".$item_explicit."</itunes:explicit>\n";
      if ($data_value['keywords'] != '')
        $feed.= "      <itunes:keywords>".podcast::take_keywords($data_value['keywords'])."</itunes:keywords>\n";
      if ($data_value['datef'] == '') {
      	$pubdate = date('D, j M Y H:i:s O');
      } else {
        $timestamp = strtotime($data_value['datef'], 0);
        if ( ($timestamp === false) OR ($timestamp == -1) ) {
        	$pubdate = date('D, j M Y H:i:s O', $data_value['datef']);
        } else {
        	$pubdate = $data_value['datef'];
        }
      } 
      $feed.= "      <pubDate>".$pubdate."</pubDate>\n";
      $feed.= "      <enclosure\n";
      $feed.= "        url=\"".podcast::url_prefix($data_value['url']).
      	str_replace(' ', '%20', $data_value['url'])."\"\n"; # modif 1.3.7
      $feed.= "        length=\"".$data_value['length']."\"\n";
      $feed.= "        type=\"".$data_value['type']."\" />\n";
      $check_guid[] = $data_value['guid'];
      $feed.= "      <guid isPermaLink=\"false\">".$data_value['guid']."</guid>\n";
      if ($data_value['author'] == '') {
        $feed.= "      <dc:creator>".dc_blog_name."</dc:creator>\n";
      } else {
        if (($data_value['author'] != '') AND strpos($data_value['author'], '@') === false) # si nom pas email
         $feed.= "      <dc:creator>".$data_value['author']."</dc:creator>\n";
      }
      /* 13/04/2006 FeedValidator : Avoid content:encoded - description longue
      if ($data_value['summary'] != '')
        $feed.= "      <content:encoded>".$data_value['summary']."</content:encoded>\n";
      */
      $feed.= "    </item>\n";
    } # fin foreach item
    $feed.= "  </channel>\n";
    $feed.= "</rss>\n";
    if (dc_encoding != 'UTF-8') $feed = utf8_encode($feed); # conversion de ISO-8859-1 en UTF-8
    # vrif pas de GUID dupliqu
    $checkUnique = create_function('$data_value','if ($data_value > 1) return true;');
    $check_guid_unique = array_keys (array_filter (array_count_values($check_guid), $checkUnique));
    if ( count($check_guid_unique) > 0 ) {
      $list = '<br />';
      foreach ($check_guid_unique as $data_value) $list .= $data_value . '<br />';
      $errors[] = __('Duplicate(s) GUID found in the podcast RSS 2.0 feed. See documentation.') .
      $list;
    }
    # save the RSS file
    $feedFile = fopen(podcast::file_of(constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1)).'.'.dc_podcast_feed_ext, "w+");
    if ($feedFile) {
      fputs($feedFile,$feed);
      fclose($feedFile);
    } else {
      $errors[] = __('Error creating podcast, please check write permissions.');
      $rc = false;
    }
    if ($rc) {
      return $nbr_items;
    } else { 
      return false;
    }
  } # fin de generate_feed
  
  # cration des fils de syndication RSS 2.0
  function generate_syndication_feeds()
  {
    global $con, $blog, $errors, $feed_names, $feed_keys, $feed_specifics;
    $rc = true; $results = array();
    $sql = 'SELECT * FROM `' . DB_PREFIX . 'podcast` ORDER BY `datef` DESC LIMIT 0,' . dc_podcast_feed_items_limit;
    $rs = $con->select($sql);
    $data = $rs->getData();
    unset($rs);
  	foreach($feed_names as $key => $value) {
    	$fn = podcast::file_of(constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1));
      if ( $key == $feed_keys[0] ) {
      	# les items, le suffixe du fichier, les noms de fil pour slection
      	$rc = podcast::generate_feed($data, $key); # le fil gnral
      } else {
      	$rc = podcast::generate_feed($data, $key,	$value); # le fil spcifique $value
      }
      if ($rc !== false) $results[] = $key.'/'.$rc;
      # gneration du fil RSS php s'il n'existe pas
      if ( @file_exists($fn.'.php') === false) {
      	# l'adresse du fichier, url du fichier, nom pr statistique
        $rc = podcast::generate_php_feed($fn.'.php', 
        	podcast::url_of(constant('dc_podcast_rss_2_0_feed_path'.$key).substr($key, 1).'.'.dc_podcast_feed_ext), $value);
        if ($rc !== false) $results[] = $key;
      }
    }
    return $results;
  } # fin de generate_syndication_feeds

  # test du fichier et rcupration caractristiques
  function get_audio_file($url_item)
  {
  	global $feed_names, $feed_keys;
    if (strpos($url_item, '/') === false) { # pas de chemin : chemin par dfaut de la config gnrale
      $filename = podcast::file_of(dc_podcast_audio_feed_path.$url_item);
      $url = podcast::url_of(dc_podcast_audio_feed_path.$url_item);
    } else { # chemin donn en entre
    	$filename = podcast::file_of($url_item);
      $url = podcast::url_of($url_item);
    }
    # Rcupre dans le tableau $elts la chane suivant le dernier . de $fichier,
    # ou une chane vide s'il n'y a pas de point.
    ereg("\.([^\.]*$)", $filename, $elts); # $ext = $elts[1];

    if (file_exists($filename)) {
      return array(filesize($filename),
                   date('D, j M Y H:i:s O', filemtime($filename)),
                   basename($filename),
                   ucfirst(basename($filename, '.mp3')),
                   $url,
                   $elts[1]);
    } else {
      return false;
    }
  } # fin de get_audio_file
  
   
  function get_remote_file($url, $headers=array(), $num_redir=0)
  {
  global $errors;
  	unset($headers['response'],$headers['location']);
  	$url = str_replace(' ', '%20', $url);
    $url_info=parse_url($url);
    $port = isset($url_info['port']) ? $url_info['port'] : 80;
    $fp=fsockopen($url_info['host'], $port, $errno, $errstr, 30);
    if($fp) {
      $head = "HEAD ".@$url_info['path']."?".@$url_info['query'];
      $head .= " HTTP/1.0\r\nHost: ".@$url_info['host']."\r\n\r\n";
      
    fputs( $fp, $head );
	while ( !feof( $fp ) && strpos( $response, "\r\n\r\n" ) == false )
		$response .= fgets( $fp, 2048 );
	fclose( $fp );
	
	preg_match_all('/(.*?): (.*)\r/', $response, $matches);
	$count = count($matches[1]);
	for ( $i = 0; $i < $count; $i++) {
		$key = strtolower($matches[1][$i]);
		$headers["$key"] = $matches[2][$i];
	}

	preg_match('/.*([0-9]{3}).*/', $response, $return);
	$headers['response'] = $return[1]; // HTTP response code eg 204, 200, 404
    if ($num_redir<5 && ('302' == $headers['response'] || '301' == $headers['response']) && isset($headers['location']) )
        return podcast::get_remote_file($headers['location'], $headers, ++$num_redir);

      if (count($headers)>1) return $headers;
      else return false;
       
    } else return false; 
  } # fin de get_remote_file

  # cration de l'url ; acquisition des champs associs
  # ce qui permet de copier le flux audio video dans son rpertoire aprs enregistrement
  function checkAudioURL($name)
  {
    if ($name == '') return false;
    global $url, $length, $datef, $guid, $type, $errors;
    if (strpos($name, '/') === false)
      $name = dc_podcast_audio_feed_path.$name; # pas de chemin : chemin par dfaut de la config gnrale
  	$url_site = util::getHost();
    if ( (substr($name, 0, 7) != 'http://') OR (substr($name, 0, strlen($url_site)) == $url_site) ) { # nom de fichier sur le serveur
    	if (substr($name, 0, 7) != 'http://') { # nom de fichier par rpertoire/nom
      	$audio_file  = podcast::get_audio_file($name);
      } else { # nom de fichier par url
      	$audio_file  = podcast::get_audio_file(substr($name, strlen($url_site)));
      }
    	if ( $audio_file !== false)
      {
        $url = $audio_file[4];
        $length = $audio_file[0];
        if ($datef =='') $datef = $audio_file[1];
        if ($guid == '') {
          $guid = $audio_file[2]; # basename
        } elseif (stripos($guid, $audio_file[2]) === false) {
          $guid.= ' ' . $audio_file[2]; # basename
        }
        $ext = $audio_file[5];
      } else { # le nom de flux donn n'a pas de fichier correspondant
        $errors[] = $name . ' - ' . __('not found') .
            '<br />' . __('Copy the file to the right directory, then retry') .
            ' <em>' . __('Save') . '</em>';
        return false;
      }
    } else { # adresse URL d'un fichier remote
      if ( ($infos = podcast::get_remote_file($name)) !== false)
      {
      	$url = $name;
        $length = $infos["content-length"];
        if ($datef =='') $datef = $infos["date"];
        if ($guid == '') $guid = basename($name); # basename si pas initialis
        ereg("\.([^\.]*$)", $name, $elts);
        $ext = $elts[1];
      } else { # pas de fichier correspondant  l'URL
        $errors[] = $name . ' - ' . __('not found') .
            '<br />' . __('Wrong URL or fsockopen not allowed for').' '.$name;
        return false;
      }
    }
    if ($ext != '')
    { # traitement du type MIME
      $ext = strtolower($ext);
      if ($ext == 'mp3') $type = 'audio/mpeg'; # Fichier audio MPEG
      elseif ($ext == 'm4a') $type = 'audio/x-m4a'; # Fichier audio AAC
      elseif ($ext == 'm4v') $type = 'video/x-m4v'; # Fichier de donnes MPEG-4
      elseif ($ext == 'mp4') $type = 'video/mp4'; # Fichier de donnes MPEG-4
      elseif ( ($ext == 'mov') OR ($ext == 'qt') ) $type = 'video/quicktime'; # Squence QuickTime mov,qt
      elseif ($ext == 'pdf') $type = 'application/pdf'; # Acrobat
      # fin des extensions types pour iTunes
      elseif ($ext == 'm4p') $type = 'audio/x-m4p'; # Fichier audio AAC
      elseif ($ext == 'm4b') $type = 'audio/x-m4b';
      elseif ( ($ext == 'au') OR ($ext == 'snd') ) $type = 'audio/basic'; # Fichier audio
      elseif ( ($ext == 'aif') OR ($ext == 'aiff') OR ($ext == 'aifc') ) $type = 'audio/x-aiff'; # Format audio AIFF
      elseif ($ext == 'wav') $type = 'audio/x-wav'; # 	Fichier audio Windows
      elseif ($ext == 'wma') $type = 'audio/x-ms-wma'; # 	Fichier audio Windows
      elseif ($ext == 'swf') $type = 'application/x-shockwave-flash'; # Macromedia Flash movie
      elseif ($ext == 'avi') $type = 'video/msvideo'; # Vido Microsoft Windows
      elseif ($ext == 'wmv') $type = 'video/x-ms-wmv'; # Vido Microsoft Windows
      elseif ($ext == 'asf') $type = 'video/x-ms-asf'; # Vido Microsoft Windows
      elseif ( ($ext == 'mpeg') OR ($ext == 'mpg') OR ($ext == 'mpe') ) $type = 'video/mpeg'; # Fichier vido MPEG
      elseif ($ext == 'flv') $type = 'video/x-flv'; # Fichier vido FLV
      # video/x-flv is not on the official IANA mime type list at this moment: http://www.iana.org/assignments/media-types/
      elseif ( in_array($ext, array('ra', 'rm', 'ram')) ) $type = 'audio/x-pn-realaudio-plugin'; # Fichier vido Real
    }
    if (!isset($type)) $type = $infos["content-type"];
    return true;
  } # fin de checkAudioURL

  # rcupration de l'id d'un billet  partir de son lien permanent
  # dcGetMod layout/lib.mod.php
  function GetPostId($url_post)
  {
    $args = '';
    $url_blog = util::getHost() . dc_blog_url .
                ((dc_url_scan == 'path_info') ? '/' : '?');
    if (substr($url_post, 0, strlen($url_blog)) == $url_blog)
      $args = substr($url_post, strlen($url_blog));
    if (substr($args, 0, 1) == '?') $args = substr($args, 1); 
    if($args != '')
    {
      if(preg_match('!^([0-9]{4}/[0-9]{2})(/|\z)!',$args,$match))
      {
        $d = $match[1];
        if(preg_match('!^([0-9]{4}/[0-9]{2}/[0-9]{2})(/|\z)!',$args,$match))
        {
          $d = $match[1];
          if(preg_match('!^[0-9]{4}/[0-9]{2}/[0-9]{2}/([0-9]+)!',$args,$match))
          {
            $p = $match[1];
          }
        }
      }
      elseif(preg_match('!^([A-Z][A-Za-z0-9_-]*)([^/]*)?(/|\z)!',$args,$match))
      {
        $cat = $match[1];
        if(preg_match('!^[A-Z][A-Za-z0-9_-]*([^/]*?)/([0-9]{4}/[0-9]{2})!',$args,$match))
        {
          $d = $match[2];
          if(preg_match('!^[A-Z][A-Za-z0-9_-]*([^/]*)?/([0-9]{4}/[0-9]{2}/[0-9]{2})!',$args,$match))
          {
            $d = $match[2];
          }
        }
      }
    }
    if (isset($p)) {
      return $p;
    } else {
      return false;
    }
  } # fin de GetPostId

  /**
  @function dcGetTextPost - Rcupre le billet par ID : titre, chapo, corps du billet
  @param entier $id    un entier qui est l'ID d'un billet (47 ou '47')
  le chapo et le corps HTML sont convertis en texte avec class.html2text.inc
  */
  function dcGetTextPost($id='')
  {
    global $blog;
    if (is_numeric($id)) {
      $blog->setPubMode(NULL); # tous les billets  
      $rs = $blog->getPostByID($id);
      $blog->setPubMode(1); # billets en ligne
    } else {
      return false;
    }
    if (!$rs->isEmpty()) {
      $res[0] = $rs->f('post_titre');
      $res[1] = $rs->f('post_chapo');
      $html_post = $res[1]; 
      $h2t =& new html2text($res[1]);
			$res[1] = $h2t->get_text();
      $res[2] = $rs->f('post_content');
      $html_post.= $res[2];
      $h2t =& new html2text($res[2]);
			$res[2] = $h2t->get_text();
      $res[3] = util::getHost().sprintf($rs->blog->front_url['post'],$rs->f('postyear'),
            $rs->f('postmonth'),$rs->f('postday'),
            $rs->f('post_id'),$rs->f('post_titre_url'));
      if ($res[1] == '') { # pas de chapeau
        $res[1] = $res[2]; # le corps du billet sera la description <description> <itunes:subtitle>
        $res[2] = ''; # pas de description longue <content:encoded> <itunes:summary>
      }
      $res[4] = ''; # on transmet le libell de la catgorie
      $rscat = $blog->getCat($rs->f('cat_id'));
      if (!empty($rscat)) {
        $res[4] = $rscat->f('cat_libelle_url');
      }
      $res[5] = ''; # recherche <a href="http://...demo.mp3" rel="enclosure">podcast</a>
      # si rel="enclosure" trouv, prend le 1er
    	if( preg_match_all( "((http://(([[:punct:]]|[[:alnum:]])*))\"(.*)?(rel=\"enclosure\"))" ,
				$html_post,$result,PREG_SET_ORDER) ) $res[5] = $result[0][1];
      return $res;
    } else {
      return false;
    }
  } # fin dcGetTextPost
  
  function checkPostURL($str)
  {
    global $title, $descf, $summary, $post, $comments, $keywords, $errors, $url;
    if ($str == '') return false;
    $post_id = $str; # on cherche l'id du billet
    if (substr($str, 0, 7) == 'http://') { # adresse URL d'un billet
      if ( ($post_id = podcast::GetPostId($str)) === false ) return false;
    }
    if ( !is_numeric($post_id) ) return false;
    if ( ($text = podcast::dcGetTextPost($post_id)) === false ) return false;
    $title = $text[0];
    $descf = $text[1];
    $summary = $text[2];
    if (substr($str, 0, 7) != 'http://') $post = $text[3];
    $comments = $text[3];
    if ( stripos($keywords, $text[4]) === false )
      $keywords = $keywords  . ' ' . $text[4];
    if ($text[5] != '') $url = $text[5];
    return true;
  } # fin de checkPostURL

/*******************************************************************************
* Les fonctions d'installation, de mise  jour, de vrification
*******************************************************************************/

	function specValue($ct)
  {
  	global $feed_suffix;
    if ( !defined($ct.$feed_suffix) ) define($ct.$feed_suffix, constant($ct));
    return constant($ct.$feed_suffix);
  }
  # traitement des spcifications de fil RSS
	function processSpec($ct, $value)
  {
  	global $feed_suffix, $objConf;
    if ( defined($ct.$feed_suffix) ) {
      podcast::updateSpec($ct.$feed_suffix, $value);
    } else { # mise  jour specific avec valeur de rfrence
    	define($ct.$feed_suffix, constant($ct));
      $objConf->edit_Spec($ct.$feed_suffix, constant($ct));
    }
  }
  # test des changements des spcifications de fil RSS
	function testSpecChange($array_ct)
  {
  	global $feed_suffix;
    foreach ($array_ct as $ct) {
      if ( ($_POST[$ct.$feed_suffix]) != constant($ct.$feed_suffix) )
        podcast::updateSpec('dc_podcast_feeds', 'no');
    }
  }
	# traitement des spcifications gnrales de configuration
	function updateSpec($id, $value, $type='string', $label='')
  {
  	global $objConf;
    if (isset($GLOBALS['dc_settings'])) {
	    $GLOBALS['dc_settings']->put($id, $value, $type, $label);
    } else {
      $objConf->edit_Spec($id, $value);
    }
  }
  
  function updConf($id, $value, $type='string', $label='', $msg=1)
  {
  	global $objConf;
    if (isset($GLOBALS['dc_settings'])) {
	    $GLOBALS['dc_settings']->put($id, $value, $type, $label);
    } else {
      $objConf->edit_Spec($id, $value);
      //*
      if (podcast::saveConf() AND $msg)
      	 buffer::str('<br />'.$id.' = '.$value);
      # */
    }
  }
  
  function saveConf()
	{
		global $objConf;
		if (!isset($GLOBALS['dc_settings'])) {
			if ( $objConf->save_confFile() === false) {
      		buffer::str('<div class="erreur"><p><strong>'.$cons.'</strong> '.$val.' '.__('not updated').'</p></div>');
  	    return false;
      } else {
    		if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
    		files::touch(DC_UPDATE_FILE,time());
        return true;
    		}
    	}
    }
	}

  /*
  - lecture du conf.ini
  - si non standard, re-criture d'un conf_standard.ini 
  - rename conf.ini en conf_non_standard_old.ini
  - rename conf_standard.ini en conf.ini
  */
  function convert_podcast()
  {
  	global $dcpodcast_plugin_name, $conf_file, $errors;
    if (is_writeable(DC_SHARE_DIR.'/'.$dcpodcast_plugin_name)) {
  		if (@file_exists($conf_file)) {
      	$str = file_get_contents($conf_file);
        if (strpos($str, 'dcpodcast_') === false) return true;
        $str = str_replace('dcpodcast_', 'dc_podcast_', $str);
        $handle = fopen(DC_SHARE_DIR.'/'.$dcpodcast_plugin_name.'/conf_standard.ini', "w");
        if (fwrite($handle, $str) === false) {
         buffer::str('<p>Impossible d\'crire dans le fichier '.DC_SHARE_DIR.'/'.$dcpodcast_plugin_name.'/conf_standard.ini'.'</p>');
         return false;
        } else {
        	fclose($handle);
          rename($conf_file, DC_SHARE_DIR.'/'.$dcpodcast_plugin_name.'/conf_non_standard_old.ini');
          rename(DC_SHARE_DIR.'/'.$dcpodcast_plugin_name.'/conf_standard.ini', $conf_file);
          buffer::str('<p>'.DC_SHARE_DIR.'/'.$dcpodcast_plugin_name.'/conf_standard.ini - converted</p>');
        }
      }
      return true;
    } else {
    	buffer::str('<div class="erreur"><p><strong>'.DC_SHARE_DIR.'/'.$dcpodcast_plugin_name .
    				'</strong> pas disponible en criture</p></div>');
      return false;
    }
  }

  function check_conf_ini($sf='')
  {
  	global $dc_podcast_plugin_name;
    # configuration du plugin, spcifications gnrales
    if ($sf == '') {
    if (!defined('dc_podcast_feed_tags')) podcast::updateSpec('dc_podcast_feed_tags', 'Podcast', 'string', 'Feed names');
    if (!defined('dc_podcast_feed_ext')) podcast::updateSpec('dc_podcast_feed_ext', 'xml', 'string', 'Feed extension');
    if (!defined('dc_podcast_audio_feed_path')) podcast::updateSpec('dc_podcast_audio_feed_path',	'share/audio/', 'string', 'Audio video directory');
    if (!defined('dc_podcast_generate_feeds')) podcast::updateSpec('dc_podcast_generate_feeds', 'yes', 'string', 'Automatic generation');
    if (!defined('dc_podcast_player')) podcast::updateSpec('dc_podcast_player', 'dew', 'string', 'Player MP3');
    if (!defined('dc_podcast_make_post')) podcast::updateSpec('dc_podcast_make_post', 'no', 'string', 'Make post verbose');
    if (!defined('dc_podcast_title_length')) podcast::updateSpec('dc_podcast_title_length', 50, 'integer', '');
    if (!defined('dc_podcast_displayed_items_per_page')) podcast::updateSpec('dc_podcast_displayed_items_per_page', 20, 'integer', '');
    if (!defined('dc_podcast_feed_items_limit')) podcast::updateSpec('dc_podcast_feed_items_limit', 999, 'integer', '');
    if (!defined('dc_podcast_feed_items_number')) podcast::updateSpec('dc_podcast_feed_items_number', 999, 'integer', '');
    if (!defined('dc_podcast_version')) podcast::updateSpec('dc_podcast_version', $dc_podcast_version, 'string', 'Podcast version');
    if (!defined('dc_podcast_feeds')) podcast::updateSpec('dc_podcast_feeds', 'no', 'string', 'Feed state');
    if (!defined('dc_podcast_prefix')) podcast::updateSpec('dc_podcast_prefix', 'no', 'string', 'Podcast prefix');
    # signature for related post
    if (!defined('dc_podcast_signature')) podcast::updateSpec('dc_podcast_signature',	'', 'string', 'Signature');
    }
		# channel specs
    if (!defined('dc_podcast_rss_2_0_feed_path'.$sf)) podcast::updateSpec('dc_podcast_rss_2_0_feed_path'.$sf,
    	( defined('dc_podcast_rss_2_0_feed_path') ? dc_podcast_rss_2_0_feed_path : 'share/feeds/'), 'string', 'Podcast address');
		if (!defined('dc_podcast_feed_title'.$sf)) podcast::updateSpec('dc_podcast_feed_title'.$sf,
    	( defined('dc_podcast_feed_title') ? dc_podcast_feed_title : dc_blog_name), 'string', 'Podcast title');
    if (!defined('dc_podcast_feed_post'.$sf)) podcast::updateSpec('dc_podcast_feed_post'.$sf,
    	( defined('dc_podcast_feed_post') ? dc_podcast_feed_post : util::getHost().dc_app_url.'/'), 'string', 'URL post');
    if (!defined('dc_podcast_feed_lang'.$sf)) podcast::updateSpec('dc_podcast_feed_lang'.$sf,
    	( defined('dc_podcast_feed_lang') ? dc_podcast_feed_lang : DC_LANG), 'string', 'Podcast language');
    if (!defined('dc_podcast_feed_editor'.$sf)) podcast::updateSpec('dc_podcast_feed_editor'.$sf,
    	( defined('dc_podcast_feed_editor') ? dc_podcast_feed_editor : ''), 'string', 'Podcast editor');
    if (!defined('dc_podcast_channel_pubdate'.$sf)) podcast::updateSpec('dc_podcast_channel_pubdate'.$sf,
    	( defined('dc_podcast_channel_pubdate') ? dc_podcast_channel_pubdate : ''), 'string', 'Publication date');
    if (!defined('dc_podcast_feed_category'.$sf)) podcast::updateSpec('dc_podcast_feed_category'.$sf,
    	( defined('dc_podcast_feed_category') ? dc_podcast_feed_category : 'Podcast'), 'string', 'RSS feeds categories');
    if (!defined('dc_podcast_feed_copyr'.$sf)) podcast::updateSpec('dc_podcast_feed_copyr'.$sf,
    	( defined('dc_podcast_feed_copyr') ? dc_podcast_feed_copyr : 'Copyright 2006'), 'string', 'Copyright');
    if (!defined('dc_podcast_feed_license'.$sf)) podcast::updateSpec('dc_podcast_feed_license'.$sf,
    	( defined('dc_podcast_feed_license') ? dc_podcast_feed_license : ''), 'string', 'Podcast license');
    if (!defined('dc_podcast_feed_image'.$sf)) podcast::updateSpec('dc_podcast_feed_image'.$sf,
    	( defined('dc_podcast_feed_image') ? dc_podcast_feed_image : ''), 'string', 'Podcast image');
    if (!defined('dc_podcast_feed_ttl'.$sf)) podcast::updateSpec('dc_podcast_feed_ttl'.$sf,
    	( defined('dc_podcast_feed_ttl') ? dc_podcast_feed_ttl : '1440'), 'string', 'Podcast image');
		if (!defined('dc_podcast_itunes_new_feed'.$sf)) podcast::updateSpec('dc_podcast_itunes_new_feed'.$sf,
    	( defined('dc_podcast_itunes_new_feed') ? dc_podcast_itunes_new_feed : ''), 'string', 'iTunes image');
    # iTunes channel specs
    if (!defined('dc_podcast_itunes_subtitle'.$sf)) podcast::updateSpec('dc_podcast_itunes_subtitle'.$sf,
    	( defined('dc_podcast_itunes_subtitle') ? dc_podcast_itunes_subtitle : dc_blog_name.' Podcasting in action'), 'string', 'Podcast description');
    if (!defined('dc_podcast_itunes_summary'.$sf)) podcast::updateSpec('dc_podcast_itunes_summary'.$sf,
    	( defined('dc_podcast_itunes_summary') ? dc_podcast_itunes_summary : dc_blog_name.' Podcasting Welcome iTunes Listeners'), 'string', 'Informations');
    if (!defined('dc_podcast_feed_cat_itun'.$sf)) podcast::updateSpec('dc_podcast_feed_cat_itun'.$sf,
    	( defined('dc_podcast_feed_cat_itun') ? dc_podcast_feed_cat_itun : 'International, French'), 'string', 'Category subcategory');
    if (!defined('dc_podcast_feed_cat1_itun'.$sf)) podcast::updateSpec('dc_podcast_feed_cat1_itun'.$sf,
    	( defined('dc_podcast_feed_cat1_itun') ? dc_podcast_feed_cat1_itun : ''), 'string', 'Category subcategory');
    if (!defined('dc_podcast_feed_cat2_itun'.$sf)) podcast::updateSpec('dc_podcast_feed_cat2_itun'.$sf,
    	( defined('dc_podcast_feed_cat2_itun') ? dc_podcast_feed_cat2_itun : ''), 'string', 'Category subcategory');
    if (!defined('dc_podcast_itunes_explicit'.$sf)) podcast::updateSpec('dc_podcast_itunes_explicit'.$sf,
    	( defined('dc_podcast_itunes_explicit') ? dc_podcast_itunes_explicit : 'no'), 'string', 'Explicit');
    if (!defined('dc_podcast_itunes_image'.$sf)) podcast::updateSpec('dc_podcast_itunes_image'.$sf,
    	( defined('dc_podcast_itunes_image') ? dc_podcast_itunes_image : ''), 'string', 'iTunes image');
    # item default specifications
    if (!defined('dc_podcast_item_author'.$sf)) podcast::updateSpec('dc_podcast_item_author'.$sf,
    	( defined('dc_podcast_item_author') ? dc_podcast_item_author : ''), 'string', 'Items author');
		if (!defined('dc_podcast_item_license'.$sf)) podcast::updateSpec('dc_podcast_item_license'.$sf,
    	( defined('dc_podcast_item_license') ? dc_podcast_item_license : ''), 'string', 'Item license');
    # iTunes item default specifications
    if (!defined('dc_podcast_itunes_keywords'.$sf)) podcast::updateSpec('dc_podcast_itunes_keywords'.$sf,
    	( defined('dc_podcast_itunes_keywords') ? dc_podcast_itunes_keywords : ''), 'string', 'Keywords');
    
    podcast::saveConf();
    return;
  }

  /**
  @function checkPluginShareDir
  
   Vrifie l'existence d'un sous rpertoire portant le nom du plugin
   dans le dossier share/
   Ce sous dossier sera utilis pour stocker les ventuelles informations
   de configuration ou autres fichiers relatifs au plugin nomm.
  
   Si le dossier n'existe pas, cette mthode essaiera de le crer et
   d'y placer un fichier .htaccess
  
   La fonction renvoie TRUE en cas de russite (dossier existant ou
   cr avec succs), FALSE sinon.
  
   @param string	dirname	Le nom du sous dossier recherch
   @param boolean	protect	Flag pour protger ou non l'accs par HTTP
   						 ce rpertoire
  
   @return	boolean
   */
  function checkPluginShareDir($dirname,$protect = true)
  {
  	$my_share_dir = DC_SHARE_DIR.'/'.$dirname;
  	$dir_exists = true;
  
  	if (!is_dir($my_share_dir)) {
  		$dir_exists = false;
  
  		// Si PHP en safe_mode, on laisse l'utilisateur crer
  		// manuellement le sous rpertoire dans share/
  		if (ini_get('safe_mode') != false) return($dir_exists);
  
  		if (is_writeable(DC_SHARE_DIR)) {
  			@umask(000);
  			if (@mkdir($my_share_dir, 0777)) {
  				$dir_exists = true;
  
  				// Creation d'un .htaccess dans le rpertoire
  				if ($fh = @fopen($my_share_dir.'/.htaccess', "wb")) {
  					$deny_str = $protect?'':'#';
  					$deny_str .= "Deny from all\n";
  					fwrite($fh,
  						"# Comment/uncomment the lines below depending of your needs\n".
  						"# To deny any access to this directory\n".
  						$deny_str
  						);
  					fclose($fh);
  				}
  			}
  		}
  
  	}
  	return($dir_exists);
  }

  function check_table()
  {
  	global $con, $dc_podcast_plugin_name;
    $check_table = true;
		# la table existe, on passe la description en text pour des versions antrieures
    $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` CHANGE `descf` `descf` text NOT NULL';
    if (!$con->execute($query)) $check_table = false;
    $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` CHANGE `category` `category` VARCHAR(255) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL';
    if (!$con->execute($query)) $check_table = false;
		# mise  jour  partir du 1er format de table
  	$check_table = true;
    if ($con->select('SELECT `summary` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `summary` text NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `post` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `post` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `comments` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `comments` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `author` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `author` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `category` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `category` varchar(40) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `marks` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `marks` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `status` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `status` varchar(8) DEFAULT \'1\' NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `duration` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `duration` varchar(8) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `explicit` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `explicit` varchar(8) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `keywords` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `keywords` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `license` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `license` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    if ($con->select('SELECT `cat_itun` FROM `'.DB_PREFIX.$dc_podcast_plugin_name.'`') === false) {
      $query = 'ALTER TABLE `'.DB_PREFIX.$dc_podcast_plugin_name.'` ADD COLUMN `cat_itun` varchar(255) NOT NULL';
      if (!$con->execute($query)) $check_table = false;
    }
    return $check_table;
  }
  
  function create_table()
  {
  	global $con, $dc_podcast_plugin_name;
		$query = "CREATE TABLE `".DB_PREFIX.$dc_podcast_plugin_name."` (" .
    "`id` mediumint(8) unsigned NOT NULL auto_increment," .
    "`title` varchar(255) NOT NULL default ''," .
    "`descf` text NOT NULL default ''," .
    "`summary` text NOT NULL default ''," .
    "`post` varchar(255) NOT NULL default ''," .
    "`comments` varchar(255) NOT NULL default ''," .
    "`license` varchar(255) NOT NULL default ''," .
    "`url` varchar(255) NOT NULL default ''," .
    "`length` varchar(40) NOT NULL default ''," .
    "`type` varchar(40) NOT NULL default ''," .
    "`guid` varchar(255) NOT NULL default ''," .
    "`author` varchar(255) NOT NULL default ''," .
    "`category` varchar(255) NOT NULL default ''," .
    "`cat_itun` varchar(255) NOT NULL default ''," .
    "`datef` varchar(40) NOT NULL default ''," .
    "`marks` varchar(255) NOT NULL default ''," .
    "`status` varchar(8) NOT NULL default '1'," .
    "`duration` varchar(8) NOT NULL default ''," .
    "`explicit` varchar(8) NOT NULL default ''," .
    "`keywords` varchar(255) NOT NULL default ''," .
    "`user_id` varchar(100) binary default ''," .
    "PRIMARY KEY  (`id`)" .
    ") TYPE=MyISAM;";
    if ($con->execute($query)) {
      return true;
    } else {
      return false;
    }
  }
  
  function iTunesCategoryOptions() {
    $cats = array(__('No') => '');
    # iTunes Categories for Podcasting. Last Modified: 2006-07-01
    $cats['Arts'] = 'Arts';
    $cats['Arts, Design'] = 'Arts, Design';
    $cats['Arts, Fashion &amp; Beauty'] = 'Arts, Fashion &amp; Beauty';
    $cats['Arts, Food'] = 'Arts, Food';
    $cats['Arts, Literature'] = 'Arts, Literature';
    $cats['Arts, Performing Arts'] = 'Arts, Performing Arts';
    $cats['Arts, Visual Arts'] = 'Arts, Visual Arts';
    
    $cats['Business'] = 'Business';
    $cats['Business, Business News'] = 'Business, Business News';
    $cats['Business, Careers'] = 'Business, Careers';
    $cats['Business, Investing'] = 'Business, Investing';
    $cats['Business, Management &amp; Marketing'] = 'Business, Management &amp; Marketing';
    $cats['Business, Shopping'] = 'Business, Shopping';
    
    $cats['Comedy'] = 'Comedy';
    
    $cats['Education'] = 'Education';
    $cats['Education, Higher Ed'] = 'Education, Higher Ed';
    $cats['Education, K-12'] = 'Education, K-12';
    $cats['Education, Language Courses'] = 'Education, Language Courses';
    $cats['Education, Training'] = 'Education, Training';
    
    $cats['Games &amp; Hobbies'] = 'Games &amp; Hobbies';
    $cats['Games &amp; Hobbies, Automotive'] = 'Games &amp; Hobbies, Automotive';
    $cats['Games &amp; Hobbies, Aviation'] = 'Games &amp; Hobbies, Aviation';
    $cats['Games &amp; Hobbies, Hobbies'] = 'Games &amp; Hobbies, Hobbies';
    $cats['Games &amp; Hobbies, Other Games'] = 'Games &amp; Hobbies, Other Games';
    $cats['Games &amp; Hobbies, Video Games'] = 'Games &amp; Hobbies, Video Games';
    
    $cats['Government &amp; Organizations'] = 'Government &amp; Organizations';
    $cats['Government &amp; Organizations, Local'] = 'Government &amp; Organizations, Local';
    $cats['Government &amp; Organizations, National'] = 'Government &amp; Organizations, National';
    $cats['Government &amp; Organizations, Non-Profit'] = 'Government &amp; Organizations, Non-Profit';
    $cats['Government &amp; Organizations, Regional'] = 'Government &amp; Organizations, Regional';
    
    $cats['Health'] = 'Health';
    $cats['Health, Alternative Health'] = 'Health, Alternative Health';
    $cats['Health, Fitness &amp; Nutrition'] = 'Health, Fitness &amp; Nutrition';
    $cats['Health, Self-Help'] = 'Health, Self-Help';
    $cats['Health, Sexuality'] = 'Health, Sexuality';
    
    $cats['Kids &amp; Family'] = 'Kids &amp; Family';
    
    $cats['Music'] = 'Music';
    
    $cats['News &amp; Politics'] = 'News &amp; Politics';
    
    $cats['Religion &amp; Spirituality'] = 'Religion &amp; Spirituality';
    $cats['Religion &amp; Spirituality, Buddhism'] = 'Religion &amp; Spirituality, Buddhism';
    $cats['Religion &amp; Spirituality, Christianity'] = 'Religion &amp; Spirituality, Christianity';
    $cats['Religion &amp; Spirituality, Hinduism'] = 'Religion &amp; Spirituality, Hinduism';
    $cats['Religion &amp; Spirituality, Islam'] = 'Religion &amp; Spirituality, Islam';
    $cats['Religion &amp; Spirituality, Judaism'] = 'Religion &amp; Spirituality, Judaism';
    $cats['Religion &amp; Spirituality, Other'] = 'Religion &amp; Spirituality, Other';
    $cats['Religion &amp; Spirituality, Spirituality'] = 'Religion &amp; Spirituality, Spirituality';
    
    $cats['Science &amp; Medicine'] = 'Science &amp; Medicine';
    $cats['Science &amp; Medicine, Medicine'] = 'Science &amp; Medicine, Medicine';
    $cats['Science &amp; Medicine, Natural Sciences'] = 'Science &amp; Medicine, Natural Sciences';
    $cats['Science &amp; Medicine, Social Sciences'] = 'Science &amp; Medicine, Social Sciences';
    
    $cats['Society &amp; Culture'] = 'Society &amp; Culture';
    $cats['Society &amp; Culture, History'] = 'Society &amp; Culture, History';
    $cats['Society &amp; Culture, Personal Journals'] = 'Society &amp; Culture, Personal Journals';
    $cats['Society &amp; Culture, Philosophy'] = 'Society &amp; Culture, Philosophy';
    $cats['Society &amp; Culture, Places &amp; Travel'] = 'Society &amp; Culture, Places &amp; Travel';
    
    $cats['Sports &amp; Recreation'] = 'Sports &amp; Recreation';
    $cats['Sports &amp; Recreation, Amateur'] = 'Sports &amp; Recreation, Amateur';
    $cats['Sports &amp; Recreation, College &amp; High School'] = 'Sports &amp; Recreation, College &amp; High School';
    $cats['Sports &amp; Recreation, Outdoor'] = 'Sports &amp; Recreation, Outdoor';
    $cats['Sports &amp; Recreation, Professional'] = 'Sports &amp; Recreation, Professional';
    
    $cats['Technology'] = 'Technology';
    $cats['Technology, Gadgets'] = 'Technology, Gadgets';
    $cats['Technology, IT News'] = 'Technology, IT News';
    $cats['Technology, Podcasting'] = 'Technology, Podcasting';
    $cats['Technology, Software How-To'] = 'Technology, Software How-To';
    
    $cats['TV &amp; Film'] = 'TV &amp; Film';
    return $cats;
	}
  function CreativeCommonsLicenses() {
    $ccls = array(__('No') => '');
    # Version 2.5 Licenses:
    $ccls['Attribution'] = 'http://creativecommons.org/licenses/by/2.5/';
    $ccls['Attribution-NoDerivs'] = 'http://creativecommons.org/licenses/by-nd/2.5/';
    $ccls['Attribution-NonCommercial-NoDerivs'] = 'http://creativecommons.org/licenses/by-nc-nd/2.5/';
    $ccls['Attribution-NonCommercial'] = 'http://creativecommons.org/licenses/by-nc/2.5/';
    $ccls['Attribution-NonCommercial-ShareAlike'] = 'http://creativecommons.org/licenses/by-nc-sa/2.5/';
    $ccls['Attribution-ShareAlike'] = 'http://creativecommons.org/licenses/by-sa/2.5/';
    # Version 1.0 Licenses:
    $ccls['NoDerivs'] = 'http://creativecommons.org/licenses/nd/1.0/';
    $ccls['NoDerivs-NonCommercial'] = 'http://creativecommons.org/licenses/nd-nc/1.0/';
    $ccls['NonCommercial'] = 'http://creativecommons.org/licenses/nc/1.0/';
    $ccls['NonCommercial-ShareAlike'] = 'http://creativecommons.org/licenses/nc-sa/1.0/';
    $ccls['ShareAlike'] = 'http://creativecommons.org/licenses/sa/1.0/';
    return $ccls;
	}
} # fin de class podcast
/*******************************************************************************
* Les fonctions pour le javascript (hors classe)
*******************************************************************************/
  # affichage d'une entre dans la liste
  function podcast_line($data, $i)
  {
    global $plugin_url;
    $mks = ''; $stts = '';
    $dc_podcast_item_title = ($data['title'] == '') ? __('Invalid empty field') : $data['title'];
    $dc_podcast_item_descf = ($data['descf'] == '') ? __('Invalid empty field') : ($data['descf']);
    if ($data['marks'] != '') $mks = __('Marks') . ': ' . '<strong>' . 
    	podcast::decode_str($data['marks']). '</strong>';
    if ($data['status'] == '0') $stts = '<img alt="check_off (1K)" src="images/check_off.png" height="12" width="12" />';
    return '<div class="ligne">' .
         '<h3 class="ligneTitre">' .
         '<a href="#" onclick="openClose(\'podcast' . $data['id'] . '\',0); return false;">' .
         '<img src="images/plus.png" id="img_podcast' . $data['id'] .
         '" alt="montre/masquer" title="montre/masquer" />' . '</a>&nbsp;&nbsp;' .
         $stts . '&nbsp;&nbsp;' .
         '<a href="' . $plugin_url . '&amp;mode=edit&amp;id=' . $data['id'] . '">' .
         podcast::decode_str($dc_podcast_item_title) . '</a>' .
         '</h3>' .
         '<p class="ligneInfo">' . 'GUID: ' . podcast::decode_str($data['guid']) . '</p>' .
         '<div style="display: none;" id="podcast' . $data['id'] . '" class="comment"><p>' .
         podcast::decode_str($dc_podcast_item_descf) . '<br />' .
         $data['url'] . '<br />' .
         $data['length'] . '<br />' .
         $data['datef'] . '<br />' .
         $mks .
         '</p></div>' .
         '</div>';
  } # fin de podcast_line
/*******************************************************************************
* Les fonctions pour le template (hors classe)
*******************************************************************************/
  /**
  @function dcPodcastLink
  
  Cette fonction affiche un lien vers le plugin podcast dans l'espace
  d'administration du blog dans le cas ou une session d'administration
  est ouverte (et seulement dans ce cas)  moins que l'affichage soit
  forc par dcPodcastLink(1);.
   utiliser dans le post.php.
  */
  function dcPodcastLink($aff=0, $s='<br /><a href="%s">Podcast it</a><br />')
  {
    $plugin_url = 'tools.php?p=podcast';
    $post_id = $GLOBALS['news']->f('post_id');
    if ( (isset($_SESSION['sess_user_id']) AND defined('DC_ECRIRE')) OR $aff ) {
      $add_file = util::getHost() . dc_app_url .
        '/' . DC_ECRIRE . '/' . $plugin_url .'&amp;mode=add&amp;post_id=' . $post_id;
      printf($s,$add_file);
    }
  } # fin de dcPodcastLink
  
 ?>