<?php
/* ***** BEGIN LICENSE BLOCK *****
	* This is a plugin for DotClear
	*
	* DotClear is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 2 of the License, or
	* (at your option) any later version.
	*
	* DotClear is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
	* GNU General Public License for more details.
	*
	* You should have received a copy of the GNU General Public License
	* along with DotClear; if not, write to the Free Software
	* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA	02111-1307	USA
	*
	* ***** END LICENSE BLOCK *****
	*/
# For retro compatibility < 1.2.7
if (!class_exists('dcNonce')) {
        class dcNonce {
                function form() { return ''; }
        }
}
$debug = false;
require_once dirname(__FILE__) . '/functions.php';
require_once dirname(__FILE__) . '/../../../inc/classes/class.multipage.php';
require_once('class.html2text.inc');

# dfinition des variables
# ---------------------------------------------------------------------------------------------------------------------------------
$dc_podcast_version = '1.4.5.1'; # la version de ce script ; important, c'est la rfrence pour test de install, update, upgrade
# ---------------------------------------------------------------------------------------------------------------------------------
$dc_podcast_plugin_name = 'podcast';
$dc_podcast_conf_ini = 'conf.ini';
define('DC_PODCAST_ROOT', $_SERVER['DOCUMENT_ROOT'] . dc_app_url . '/' . DC_ECRIRE . '/tools/'.$dc_podcast_plugin_name.'/');
define('DC_PODCAST_CR', '#cr;');
define('DC_PODCAST_CCL', 'http://creativecommons.org/licenses/');
$conf_org_file = DC_PODCAST_ROOT.$dc_podcast_conf_ini;
$conf_file = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$dc_podcast_conf_ini;
$plugin_url = 'tools.php?p='.$dc_podcast_plugin_name;
$post_url = 'poster.php?post_id=';
$share_podcast_url = util::getHost().dc_app_url.'/share/'.$dc_podcast_plugin_name.'/';

$player_mp3 = 'dewplayer.swf';
$player = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$player_mp3;
$player_url = $share_podcast_url.$player_mp3;

$playermin_mp3 = 'dewplayer-mini.swf';
$playermin = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$playermin_mp3;
$playermin_url = $share_podcast_url.$playermin_mp3;

$playermul_mp3 = 'dewplayer-multi.swf';
$playermul = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$playermul_mp3;
$playermul_url = $share_podcast_url.$playermul_mp3;

$playervol_mp3 = 'dewplayer-vol.swf';
$playervol = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$playervol_mp3;
$playervol_url = $share_podcast_url.$playervol_mp3;

$playern_mp3 = 'player_mp3.swf';
$playern = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$playern_mp3;
$playern_url = $share_podcast_url.$playern_mp3;

$player_flv = 'player_flv.swf';
$playerv = DC_SHARE_DIR.'/'.$dc_podcast_plugin_name.'/'.$player_flv;
$playerv_url = $share_podcast_url.$player_flv;

$errors = array();

# Recherche tat normal, installation, update
# si mme version du plugin pas d'excution du code install
$dc_podcast_install = false; # pour une premire installation
$dc_podcast_upgrade = false; # pour le passage des specs de conf.ini en settings
$dc_podcast_update = false; # pour la mise  jour d'une version existante

if (@file_exists($conf_file)) {
	# Lecture du fichier de configuration
  if (!class_exists('podcast_confFile')) require_once dirname(__FILE__).'/class.conf.file.php';
	$objConf = new podcast_confFile($conf_file);
	$objConf->read_confFile($conf_file); # lecture des constantes de configuration
  if (defined("dc_podcast_version")) { # les specs existent et sont dans le format standard dc_podcast_...
  	if (dc_podcast_version != $dc_podcast_version) {
    	$dc_podcast_update = true; # update version avec constantes standard
    	buffer::str('<p class="message">'.__('Version').' '.$dc_podcast_version.' - '.__('Updating from').' '.dc_podcast_version.'</p>');
      podcast::updConf('dc_podcast_version', $dc_podcast_version); # cration ou mise  jour
    }
  } else {
  	$dc_podcast_update = true; # update version avec constantes non standard du type dcpodcast
    buffer::str('<p class="message">'.__('Version').' '.$dc_podcast_version.' - '.__('Updating from').' older version'.'</p>');
		# vrif et conversion des constantes en standard dotclear : dcpodcast_-> dc_podcast_
		# les donnes utilisateur sont prserves
    if (podcast::convert_podcast() !== false)
    	buffer::str('<p><strong>share/' . $dc_podcast_plugin_name . '/' . $dc_podcast_conf_ini . '</strong> ' . __('standard mode') . ' ' .__('verified') . '</p>');
  }
} else { # pas de fichier de configuration share/podcast/conf.ini
	buffer::str('<p class="message">'.__('Version').' '.$dc_podcast_version.' - '.__('New install').'</p>');
	$dc_podcast_install = true; # 1re installation
}

# vrif table et config, faite une fois  install-maj ou sur demande
if ( $dc_podcast_install OR $dc_podcast_upgrade OR $dc_podcast_update OR isset($_GET['check']) ) { # install ou vrif
	include dirname(__FILE__).'/install.php';
  # fin d'installation ou de vrification
  buffer::str('<p class="message">'.__('Version').' '.$dc_podcast_version.' - '.
    __('Check done').' - <a href="' . $plugin_url . '&mode=conf">'.__('Click here') . '</a></p>');
  return; # arret de l'affichage ; rappel de la page ncessaire pour rafraichir les constantes
} # fin de install vrif

include dirname(__FILE__).'/vardef.php'; # dfinition des variables
podcast::DisplayErrors($errors); # affiche les erreurs avant le titre et la liste
if ($feed_config_todo) {
	$mode = 'conf'; # vardef  dtect des specs non dfinies
} elseif ( (isset($_GET['mode']) && ($_GET['mode'] == 'add')) || isset($_POST['add']) || isset($_POST['addgetpost']) ) {
	$mode = 'add';
} elseif ((isset($_GET['mode']) && ($_GET['mode'] == 'edit')) || (isset($_POST['edit']))) {
	$mode = 'edit';
} elseif ((isset($_GET['mode']) && ($_GET['mode'] == 'expert')) || (isset($_POST['expert']))) {
	$mode = 'edit';
  $expert = true;
} elseif ( (isset($_GET['mode']) && ($_GET['mode'] == 'conf')) || isset($_POST['conf']) ) {
	$mode = 'conf';
} elseif ((isset($_GET['mode']) && ($_GET['mode'] == 'gen')) || (isset($_POST['gen']))) {
	$mode = 'gen';
} elseif (isset($_POST['delete'])) {
	$mode = 'delete';
} elseif ( (isset($_POST['postit'])) OR (isset($_POST['refreshfile'])) OR (isset($_POST['refreshpost'])) ) {
	$mode = 'edit'; # les boutons Amener le fichier ou billet ne doivent pas tre dans le form ADD
} else {
	$mode = 'list';
}
$getfile = 0; $getpost = 0; # en numrique pour transmission par $_GET
# voir si actualisation demande
if ( (isset($_GET['getfile']) && ($_GET['getfile'] == '1')) OR isset($_POST['refreshfile']) )
	$getfile = 1;
if ( (isset($_GET['getpost']) && ($_GET['getpost'] == '1') ) OR isset($_POST['refreshpost']) OR isset($_POST['addgetpost']) )
	$getpost = 1;
if ($dc_podcast_feeds == 'yes') {
	$img_gen_rss = 'images/check_on.png'; # vert
} else {
	$img_gen_rss = 'images/check_wrn.png'; # orange
}

if (!isset($_REQUEST['page'])) {
	$_REQUEST['page'] = 1;
}
switch($mode) {
	case 'gen':
	{ 
    include dirname(__FILE__).'/gen.php'; # pour traitement de Gen RSS ; on gnre le(s) fil(s) RSS
		break;
	} # fin de case 'gen'

	case 'list':
	{
		include dirname(__FILE__).'/list.php';
		break;
	} # fin de case 'list'
	case 'add':
	case 'edit':
	{
		include dirname(__FILE__).'/item.php';
		break;
	} # fin de case 'add' 'edit'

	case 'delete':
	{
  	include dirname(__FILE__).'/del.php';
		break;
	} # fin de case 'delete'

	case 'conf':
	{
  	if (isset($_GET['feed_suffix'])) {
    	$feed_suffix = $_GET['feed_suffix'];
      include dirname(__FILE__).'/form_feed.php';
    } else {
  	  include dirname(__FILE__).'/config.php';
  		break;
    }
	} # fin de case 'conf'
} # fin de switch($mode)

?>
